<?php 
/**
* dbArchive
* Create and maintain MySQL Database archives
* Copyright 2003 Amalla International. All rights reserved.
* Scott Pier - ScottBP@amalla.com
* Create Date: 01/03/2003
* Version 1.01.00
*/
class dbdump {
	var $db_name;
	var $show_data = true;
	var $prog_name = SYS_PROGRAM;
	var $prog_version = SYS_VERSION;
	var $prog_url = "http://www.amalla.com";
	var $db_host = "localhost"; 
	// Build Export for this database
	function getSchema(){ 
		// Get MySQL Version
		$sSQL = "SHOW VARIABLES LIKE 'version'";
		$result = mysql_query($sSQL);
		$row = mysql_fetch_assoc($result);
		$mysql_version = $row['Value']; 
		// Set Arch Date
		$arc_date = date("M d, Y");
		$arc_time = date("h:i A"); 
		// Setup schema header
		unset($this_schema);
		$this_schema = 
			"# " . $this -> prog_name . " MySQL-Dump\n" . 
			"# version " . $this -> prog_version . "\n" .
			"# " . $this -> prog_url . "\n" .
			"#\n" .
			"# Host: " . $this -> db_host . "\n" .
			"# Generation Time: $arc_date at $arc_time \n".
			"# Server version: $mysql_version \n".
			"# PHP Version: " . phpversion() . "\n" .
			"#\n" .
			"# Database : " . $this -> db_name . "\n" .
			"# --------------------------------------------------------\n"
		;

		// Read Tables
		$table_list = mysql_list_tables($this -> db_name);
		$field_list=array();
		$insert_fields=array();
		while (list($table_name) = mysql_fetch_array($table_list)) {
			// Build Field List
			$sSQL = "DESCRIBE $table_name"; 
			$result = mysql_query($sSQL);
			unset($field_list);
			while ($row = mysql_fetch_assoc($result)) {
				$field_name=$row['Field'];
				$insert_fields[$table_name][]=$field_name;
				$field_type=$row['Type'];
				if ($row['Null'] == "Yes") {
					$field_null = " NULL";
				} else {
					$field_null = " NOT NULL";
				} 
				if (isset($row['Default']) && $row['Default'] != '') {
					$field_default = " DEFAULT '" . $row['Default'] . "'";
				} else {
					$field_default = "";
				} 
				$field_extra = $row['Extra'];
				$field_list[]=$line_start."`$field_name` $field_type$field_default$field_null $field_extra";
			}

			// Build Key List
			$sSQL = "SHOW KEYS FROM $table_name";
			$result = mysql_query($sSQL);
			unset($key_list);
			unset($key_name);
			while ($row = mysql_fetch_assoc($result)) {
				// Check for new key name
				if ($key_name != $row['Key_name']) {
					// Close key_line if we are building
					if ($key_name) {
						//$key_list .= "),\n\t";
						$key_list .= ")";
						$field_list[]=$key_list; // Try to get this in the array
						$key_list="";
					} else {
						unset($key_list);
					} 

					$key_name = $row['Key_name']; 
					// Set Key Type
					if ($row['Key_name'] == "PRIMARY") {
						$key_type = "PRIMARY KEY ";
					} elseif ($row['Comment'] == "FULLTEXT") {
						$key_type = "FULLTEXT KEY ";
					} elseif ($row['Non_unique'] == "0") {
						$key_type = "UNIQUE KEY ";
					} else {
						$key_type = "KEY ";
					} 
					// Set Key Name Display
					if ($row['Key_name'] == "PRIMARY") {
						$show_name = "";
					} else {
						$show_name = "`" . $row['Key_name'] . "` ";
					} 
					// Start key_line
					$key_list .= $key_type . $show_name . "(`" . $row['Column_name'] . "`";
				} else {
					$key_list .= ", `" . $row['Column_name'] . "`";
				}
			} 
			$key_list .= ")"; 
			$field_list[]=$key_list; // Try to get this in the array

			// Build Insert List
			$insert_list=array();
			$this_insert_fields="(";
			for($a=0; $a<count($insert_fields[$table_name]); $a++) {
				$this_insert_fields.="`".$insert_fields[$table_name][$a]."`";
				if($a<count($insert_fields[$table_name])-1) {
					$this_insert_fields.=", ";
				}
			}
			$this_insert_fields.=") ";
			$result = mysql_query("select * from $table_name");
			$num_flds = mysql_num_fields($result);
			$num_rows = mysql_num_rows($result);
			for ($x = 0; $x < $num_rows; $x++) {
				$insert_line= "INSERT INTO `$table_name` $this_insert_fields VALUES (";
				$row = mysql_fetch_row($result);
				for ($i = 0; $i < $num_flds; $i++) {
					$type = mysql_field_type ($result, $i);
					$insert_line.= "'".mysql_escape_string($row[$i])."'";
					if ($i < ($num_flds-1)) {
						$insert_line.= ", ";
					} 
				} 
				if ($x < $num_rows-1) {
					$insert_line.= ");\n";
				} else {
					$insert_line.= ");";
				} 
				$insert_list[$x]=$insert_line;
			} 

			// Get Table type
			$sSQL = "SHOW TABLE STATUS LIKE \"$table_name\"";
			$result = @mysql_query($sSQL);
			if ($result) {
				$row = mysql_fetch_assoc($result);
				$table_type = "TYPE=" . $row['Type'];
				if ($row['Comment']) {
					$table_comment="COMMENT='".$row['Comment']."'";
				} else {
					$table_comment="";
				}
			} else {
				$table_type = "";
			} 
			// Build Scema Body
			$this_schema .= 
				"#\n" .
				"# Table structure for table `$table_name`\n" . 
				"#\n" .
				"DROP TABLE IF EXISTS `$table_name`;\n" .
				"CREATE TABLE `$table_name` ( \n";
			for ($b=0; $b<count($field_list); $b++) {
				$this_schema.="\t".$field_list[$b];
				if ($b<count($field_list)-1) {
					$this_schema.=",\n";
				} else {
					$this_schema.="\n";
				}
			}
			$this_schema.=") $table_type $table_comment;\n" .
				"\n" .
				"#\n" .
				"# Dumping data for table `$table_name`\n" .
				"#\n";
			for ($c=0; $c<count($insert_list); $c++) {
				$this_schema.=$insert_list[$c];
			}
			$this_schema.="\n# --------------------------------------------------------\n\n";
		} 
		return $this_schema;
	} 
	// Set Database Name
	function setDb ($this_db) {
		$this -> db_name = $this_db;
	} 
	// Set Program Name
	function setProgName ($this_prog) {
		$this -> prog_name = $this_prog;
	} 
	// Set Program Version
	function setProgVersion ($this_ver) 	{
		$this -> prog_version = $this_ver;
	} 
	// Set Program URL
	function setProgUrl ($this_url) 	{
		$this -> prog_url = $this_url;
	} 
	// Set Host
	function setHost ($this_host) 	{
		$this -> db_host = $this_host;
	} 
} 
?>